/** Element Factory * */

package jsparky;

import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;

public abstract class ElementFactory extends DocumentImpl {

    public RSTElement createRSTElement(String relation) {
        return new RSTElement(this, relation);
    }

    public RSTElement createRSTElement(RSTElement elem) {
        return new RSTElement(this, elem, false); // default
    }

    public RSTElement createRSTElement(RSTElement elem, boolean deep) {
        return new RSTElement(this, elem, deep);
    }

    public PropositionElement createPropositionElement(Proposition prop,
            String ns) {
        return new PropositionElement(this, prop, ns);
    }

    public PropositionElement createPropositionElement(PropositionElement elem) {
        return new PropositionElement(this, elem);
    }

    public AggregatedElement createAggregatedElement(AggregationResult result,
            RSTElement rst_elem, Operation operation) {
        return new AggregatedElement(this, result, rst_elem, operation);
    }

    public AggregatedElement createAggregatedElement(AggregatedElement elem) {
        return new AggregatedElement(this, elem);
    }

}
