/**
 * RSTElement extends ElementImpl
 * 
 * created by Ryuichiro Higashinaka 2005/05/26
 *  
 */

package jsparky;

import org.apache.xerces.dom.*;
import java.util.*;
import org.w3c.dom.*;

public class RSTElement extends BaseElement {

    String relName;

    public RSTElement(Document doc, String rel_name) {
        super((CoreDocumentImpl) doc, BaseElement.RSTELEMENT_TAGNAME);
        this.relName = rel_name;
        this.setAttribute("name", rel_name);
    }

    public RSTElement(Document doc, RSTElement rst_elem, boolean deep) {
        super((CoreDocumentImpl) doc, rst_elem.getTagName());
        this.relName = rst_elem.getRelationName();
        this.setAttribute("name", relName);
        if (deep) {
            copyTree(doc, rst_elem, this);
        }
    }

    public void copyTree(Document doc, Element parent, Element newparent) {
        for (Node child = parent.getFirstChild(); child != null; child = child
                .getNextSibling()) {
            if (child instanceof RSTElement) {
                RSTElement newelem = new RSTElement(doc, (RSTElement) child,
                        false);
                newparent.appendChild(newelem);
                copyTree(doc, (Element) child, (Element) newelem);
            } else if (child instanceof PropositionElement) {
                PropositionElement newelem = new PropositionElement(doc,
                        (PropositionElement) child);
                newparent.appendChild(newelem);
            }
        }
    }

    public String getRelationName() {
        return relName;
    }

    public short getNodeType2() {
        return BaseElement.RST_NODE;
    }

}
