/** RSTPlan * */

package jsparky;

import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;

public class RSTPlan extends ElementFactory {

    /** flat representation **/
    private List relations;

    private String strategy;

    public RSTPlan(List relations) {
        this.relations = relations;
    }

    public RSTPlan(RSTPlan rstplan) {
        this.relations = rstplan.getRelations();
        this.strategy = rstplan.getStrategy();
        //System.out.println(rstplan.getDocumentElement().getClass());
        RSTElement orgroot = (RSTElement) rstplan.getDocumentElement();
        RSTElement newroot = new RSTElement(this, orgroot, true);
        appendChild(newroot);
    }

    public String getStrategy() {
        return strategy;
    }

    public void setStrategy(String strategy) {
        this.strategy = strategy;
    }

    public List getRelations() {
        return relations;
    }

    public ArrayList getRelationsByName(String rel_name) {
        ArrayList lis = new ArrayList();
        for (int i = 0; i < relations.size(); i++) {
            Relation relation = (Relation) relations.get(i);
            String s = relation.getRelationName();
            if (s.equals(rel_name)) {
                lis.add(relation);
            }
        }
        return lis;
    }

    public ArrayList getPropositions(String rel_name, String ns) {
        ArrayList lis = new ArrayList();
        for (int i = 0; i < relations.size(); i++) {
            Relation relation = (Relation) relations.get(i);
            String s = relation.getRelationName();
            ArrayList propositions = relation.getPropositions();
            for (int j = 0; j < propositions.size(); j++) {
                Proposition prop = (Proposition) propositions.get(j);
                String _ns = relation.getNS(prop);
                if (rel_name.equals(s) && ns.equals(_ns)) {
                    lis.add(prop);
                }
            }
        }
        return lis;
    }
}
