/** operation manager **/

package jsparky.review;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import jsparky.*;
import org.apache.xerces.dom.*;

// hack some code here
public class OperationManagerEx extends jsparky.OperationManager {

    /** this performes swapping of DSS **/
    ReviewManager review_manager;
    boolean random_replace = false;
    public static final int REPLACE_PROB = 50;

    /** constructor **/
    public OperationManagerEx(ReviewManager review_manager){
	super();
	this.review_manager = review_manager;
    }

    public OperationManagerEx(ReviewManager review_manager, boolean random_replace){
	this(review_manager);
	this.random_replace = random_replace;
    }

    /** override aggregate **/
    /** if everything is under infer then, choose one from review dss **/
    protected AggregationResult aggregate(Operation operation, RSTElement rst_elem, Aggregatable a1, Aggregatable a2) throws AggregationException {
	/** setup ns ordering **/
	if(Relation.isMonoNuclear(rst_elem.getRelationName())){
	    if(a1 instanceof AggregatedElement){
		a1.setNS(Relation.SATELLITE);
	    }
	    if(a2 instanceof AggregatedElement){
		a2.setNS(Relation.SATELLITE);
	    }
	}
	/** debug print **/
	if(debug){
	    System.out.println(Utils.serialize(rst_elem));
	    System.out.println("input1 " + Utils.serialize((Element)a1));
	    System.out.println("input2 " + Utils.serialize((Element)a2));
	    if(a1.getDSS() != null){
		System.out.println(Utils.serialize(a1.getDSS().getDocumentElement()));
	    }
	    if(a2.getDSS() != null){
		System.out.println(Utils.serialize(a2.getDSS().getDocumentElement()));
		
	    }
	}
	/** focus on only recommendation tplans (2005/06/13) **/
	AggregationResult result = null;
	try{
	    if(! rst_elem.getRelationName().equals(Relation.INFER)){
		throw new DSSNotFoundException("cannot use review dss for " + rst_elem.getRelationName());
	    }
	    Document dss = review_manager.getDSSForAggregatable(a1, a2, false);
	    System.out.println("found dss : " + Utils.serialize(dss));
	    //if(Utils.trueOrFalse()){
	    // how about this??
	    if(Utils.trueOrFalse(100 - REPLACE_PROB)){
		throw new DSSNotFoundException("not using aggregated review dss");
	    }
	    result = new AggregationResult(dss,a1.getDSS(),a2.getDSS());
	    result.setOperation(new ReviewReplaceOperation());
	}catch(DSSNotFoundException dsse){
	    /** try finding indivisual dss **/
	    dsse.printStackTrace();
	    try{
		Document dss = review_manager.getDSSForAggregatable(a1,false);
		System.out.println("found dss-1 : " + Utils.serialize(dss));
		//if(Utils.trueOrFalse()){
		if(Utils.trueOrFalse(100 - REPLACE_PROB)){
		    throw new DSSNotFoundException("not using aggregated review dss");
		}
		a1 = new AggregatableWrapper(dss,a1.getNS());
	    }catch(DSSNotFoundException _dsse){
		_dsse.printStackTrace();
	    }
	    try{
		Document dss = review_manager.getDSSForAggregatable(a2,false);
		System.out.println("found dss-2 : " + Utils.serialize(dss));
		//if(Utils.trueOrFalse()){
		if(Utils.trueOrFalse(100 - REPLACE_PROB)){
		    throw new DSSNotFoundException("not using aggregated review dss");
		}
		a2 = new AggregatableWrapper(dss,a2.getNS());
	    }catch(DSSNotFoundException _dsse){
		_dsse.printStackTrace();
	    }
	    result = operation.aggregate(rst_elem, a1, a2);
	}
	if(result.getAggregatedDSS()!=null){
	    if(debug){
		System.out.println("aggregated-dss : " + Utils.serialize(result.getAggregatedDSS()));
	    }
	}
	return result;
    }

    // leave sparky style sentences or not
    public void setRandomReplace(boolean b){
	this.random_replace = b;
    }

    /** add restaurant names and process referring expressions **/
    public void postProcess(SentencePlan splan){
	AggregatedElement a = (AggregatedElement) splan.getDocumentElement();
	ref.process(a);
    }

    /** aggregatable **/
    class AggregatableWrapper implements Aggregatable {
	Document dss;
	String ns;
	public AggregatableWrapper(Document dss, String ns){
	    this.dss = dss;
	    this.ns = ns;
	}
	public Document getDSS(){
	    DocumentImpl newdss = new DocumentImpl();
	    Element newroot = (Element)newdss.importNode(dss.getDocumentElement().cloneNode(true),true);
	    newdss.appendChild(newroot);
	    return newdss;
	}
	public String getNS(){
	    return ns;
	}
	public void setNS(String ns){
	    this.ns = ns;
	}
    }

    /** dummy review replace operation **/
    class ReviewReplaceOperation extends Operation {
	public boolean isInvalidOperationInStructure(String op_name){
	    return false;
	}
	public AggregationResult aggregate(RSTElement rst_elem, Aggregatable a1, Aggregatable a2) throws AggregationException {
	    return null;
	}
	public String getOperationName(){
	    return "REPLACED_BY_USER_REVIEW";
	}
    }

}

